/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { mutateAsync, requestAsync } from '../helpers/actions';
import { defaultEntitiesSelector, NGRX_QUERY_CONFIG } from '../helpers/config';
import { Inject, Injectable } from '@angular/core';
import { Store } from '@ngrx/store';
/**
 * @record
 */
export function ConnectRequestParams() { }
function ConnectRequestParams_tsickle_Closure_declarations() {
    /** @type {?|undefined} */
    ConnectRequestParams.prototype.selector;
}
/**
 * @record
 */
export function ConnectMutateParams() { }
function ConnectMutateParams_tsickle_Closure_declarations() {
    /** @type {?|undefined} */
    ConnectMutateParams.prototype.selector;
}
export class ConnectService {
    /**
     * @param {?} store
     * @param {?} config
     */
    constructor(store, config) {
        this.store = store;
        this.config = config;
    }
    /**
     * @param {?} config
     * @return {?}
     */
    mutateAsync(config) {
        this.store.dispatch(mutateAsync(config));
        return this.select(config.selector);
    }
    /**
     * @param {?} config
     * @return {?}
     */
    requestAsync(config) {
        this.store.dispatch(requestAsync(config));
        return this.select(config.selector);
    }
    /**
     * @param {?} selector
     * @return {?}
     */
    select(selector) {
        return this.store.select(selector || this.config && this.config.entitiesSelector || defaultEntitiesSelector);
    }
}
ConnectService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ConnectService.ctorParameters = () => [
    { type: Store, },
    { type: undefined, decorators: [{ type: Inject, args: [NGRX_QUERY_CONFIG,] },] },
];
function ConnectService_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    ConnectService.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    ConnectService.ctorParameters;
    /** @type {?} */
    ConnectService.prototype.store;
    /** @type {?} */
    ConnectService.prototype.config;
}
//# sourceMappingURL=connect.service.js.map