/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { ChangeDetectorRef } from '@angular/core';
import { Optional } from '@angular/core';
import { ConnectService } from '../services/connect.service';
import { Directive, EventEmitter, Input, Output } from '@angular/core';
import { NqConnectedComponent } from './connected.component';
var ConnectRequestDirective = /** @class */ (function () {
    /**
     * @param {?} connectService
     * @param {?} changeDetector
     * @param {?} host
     */
    function ConnectRequestDirective(connectService, changeDetector, host) {
        this.connectService = connectService;
        this.changeDetector = changeDetector;
        this.host = host;
        // tslint:disable-next-line:no-input-rename
        this.config = /** @type {?} */ (undefined);
        this.response = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ConnectRequestDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.subscribe(this.config);
        if (this.host) {
            this.host.nqRefresh.subscribe(function () { return _this.forceRequest(); });
        }
    };
    /**
     * @return {?}
     */
    ConnectRequestDirective.prototype.ngOnDestroy = function () {
        this.unsubscribe();
    };
    /**
     * @param {?} config
     * @return {?}
     */
    ConnectRequestDirective.prototype.subscribe = function (config) {
        var _this = this;
        this.unsubscribe();
        this.subscription = this.connectService.requestAsync(config).subscribe(function (response) {
            if (_this.response) {
                if (_this.host) {
                    setTimeout(function () {
                        _this.host.nqData = response;
                        if (_this.host.changeDetector) {
                            _this.host.changeDetector.markForCheck();
                        }
                    });
                }
                _this.response.emit(response);
            }
        });
    };
    /**
     * @return {?}
     */
    ConnectRequestDirective.prototype.unsubscribe = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    ConnectRequestDirective.prototype.forceRequest = function () {
        this.subscribe(Object.assign({}, this.config, { force: true }));
    };
    return ConnectRequestDirective;
}());
export { ConnectRequestDirective };
ConnectRequestDirective.decorators = [
    { type: Directive, args: [{
                exportAs: 'nqConnect',
                selector: '[nqConnect]',
            },] },
];
/** @nocollapse */
ConnectRequestDirective.ctorParameters = function () { return [
    { type: ConnectService, },
    { type: ChangeDetectorRef, },
    { type: NqConnectedComponent, decorators: [{ type: Optional },] },
]; };
ConnectRequestDirective.propDecorators = {
    "config": [{ type: Input, args: ['nqConnect',] },],
    "response": [{ type: Output },],
};
function ConnectRequestDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    ConnectRequestDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    ConnectRequestDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    ConnectRequestDirective.propDecorators;
    /** @type {?} */
    ConnectRequestDirective.prototype.config;
    /** @type {?} */
    ConnectRequestDirective.prototype.response;
    /** @type {?} */
    ConnectRequestDirective.prototype.subscription;
    /** @type {?} */
    ConnectRequestDirective.prototype.connectService;
    /** @type {?} */
    ConnectRequestDirective.prototype.changeDetector;
    /** @type {?} */
    ConnectRequestDirective.prototype.host;
}
//# sourceMappingURL=connect.directive.js.map
