/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { withoutPath } from 'redux-query/dist/es/reducers/entities';
import { ConnectService } from './connect.service';
import { Injectable } from '@angular/core';
/**
 * @param {?} obj
 * @return {?}
 */
export function objectsByIdToArray(obj) {
    if (!obj) {
        return [];
    }
    return Object.keys(obj).map(function (key) { return obj[key]; });
}
;
/**
 * @param {?} array
 * @param {?} keyOf
 * @return {?}
 */
export function arrayToObjectsById(array, keyOf) {
    return array.reduce(function (objectsById, item) {
        objectsById[keyOf(item)] = item;
        return objectsById;
    }, {});
}
/**
 * @record
 * @template E
 */
export function EntityConfig() { }
function EntityConfig_tsickle_Closure_declarations() {
    /** @type {?} */
    EntityConfig.prototype.idSelector;
    /** @type {?} */
    EntityConfig.prototype.entityTypeName;
    /** @type {?} */
    EntityConfig.prototype.endpoints;
}
/**
 * @record
 */
export function CrudEndpoints() { }
function CrudEndpoints_tsickle_Closure_declarations() {
    /** @type {?} */
    CrudEndpoints.prototype.create;
    /** @type {?} */
    CrudEndpoints.prototype.remove;
    /** @type {?} */
    CrudEndpoints.prototype.getById;
    /** @type {?} */
    CrudEndpoints.prototype.list;
    /** @type {?} */
    CrudEndpoints.prototype.update;
}
/**
 * @template E
 */
var ConnectEntityService = /** @class */ (function () {
    /**
     * @param {?} connectService
     */
    function ConnectEntityService(connectService) {
        this.connectService = connectService;
    }
    /**
     * @param {?} config
     * @return {?}
     */
    ConnectEntityService.prototype.init = function (config) {
        this.config = config;
    };
    /**
     * @return {?}
     */
    ConnectEntityService.prototype.list = function () {
        var _this = this;
        return this.connectService.requestAsync({
            selector: function (s) { return objectsByIdToArray(s.entities[_this.config.entityTypeName]); },
            transform: function (response) {
                return (_a = {}, _a[_this.config.entityTypeName] = arrayToObjectsById(response, _this.config.idSelector), _a);
                var _a;
            },
            update: (_a = {},
                _a[this.config.entityTypeName] = function (prevEntities, entities) { return (Object.assign({}, prevEntities, entities)); },
                _a),
            url: this.config.endpoints.list,
        });
        var _a;
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ConnectEntityService.prototype.get = function (id) {
        var _this = this;
        return this.connectService.requestAsync({
            selector: function (s) { return s.entities[_this.config.entityTypeName] && s.entities[_this.config.entityTypeName][id]; },
            transform: function (response) {
                return (_a = {}, _a[_this.config.entityTypeName] = (_b = {}, _b[id] = response, _b), _a);
                var _a, _b;
            },
            update: (_a = {},
                _a[this.config.entityTypeName] = function (prevEntities, entities) { return (Object.assign({}, prevEntities, entities)); },
                _a),
            url: this.config.endpoints.getById(id),
        });
        var _a;
    };
    /**
     * @param {?} entity
     * @return {?}
     */
    ConnectEntityService.prototype.create = function (entity) {
        var _this = this;
        return this.connectService.mutateAsync({
            body: entity,
            optimisticUpdate: (_a = {},
                _a[this.config.entityTypeName] = function (prevEntities) {
                    return (Object.assign({}, prevEntities, (_a = {}, _a[_this.config.idSelector(entity)] = entity, _a)));
                    var _a;
                },
                _a),
            transform: function (response) {
                return (_a = {}, _a[_this.config.entityTypeName] = (_b = {}, _b[_this.config.idSelector(response)] = response, _b), _a);
                var _a, _b;
            },
            update: (_b = {},
                _b[this.config.entityTypeName] = function (prevEntities, entities) { return (Object.assign({}, prevEntities, entities)); },
                _b),
            url: this.config.endpoints.create,
        });
        var _a, _b;
    };
    /**
     * @param {?} entity
     * @return {?}
     */
    ConnectEntityService.prototype.edit = function (entity) {
        var _this = this;
        return this.connectService.mutateAsync({
            body: entity,
            optimisticUpdate: (_a = {},
                _a[this.config.entityTypeName] = function (prevEntities) {
                    return (Object.assign({}, prevEntities, (_a = {}, _a[_this.config.idSelector(entity)] = entity, _a)));
                    var _a;
                },
                _a),
            options: {
                method: 'PUT',
            },
            selector: function (s) { return s.entities[_this.config.entityTypeName][_this.config.idSelector(entity)]; },
            transform: function (response) {
                return (_a = {}, _a[_this.config.entityTypeName] = (_b = {}, _b[_this.config.idSelector(response)] = response, _b), _a);
                var _a, _b;
            },
            update: (_b = {},
                _b[this.config.entityTypeName] = function (prevEntities, entities) { return (Object.assign({}, prevEntities, entities)); },
                _b),
            url: this.config.endpoints.update,
        });
        var _a, _b;
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ConnectEntityService.prototype.delete = function (id) {
        var _this = this;
        return this.connectService.mutateAsync({
            selector: function (s) { return s.entities[_this.config.entityTypeName][id]; },
            optimisticUpdate: (_a = {},
                _a[this.config.entityTypeName] = function (prevEntities) { return withoutPath(prevEntities, [id]); },
                _a),
            options: {
                method: 'DELETE',
            },
            update: (_b = {},
                _b[this.config.entityTypeName] = function (prevEntities) { return withoutPath(prevEntities, [id]); },
                _b),
            url: this.config.endpoints.remove(id + ''),
        });
        var _a, _b;
    };
    return ConnectEntityService;
}());
export { ConnectEntityService };
ConnectEntityService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ConnectEntityService.ctorParameters = function () { return [
    { type: ConnectService, },
]; };
function ConnectEntityService_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    ConnectEntityService.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    ConnectEntityService.ctorParameters;
    /** @type {?} */
    ConnectEntityService.prototype.config;
    /** @type {?} */
    ConnectEntityService.prototype.entity;
    /** @type {?} */
    ConnectEntityService.prototype.connectService;
}
//# sourceMappingURL=connectEntity.service.js.map
