import { Action } from '@ngrx/store';
import { MUTATE_ASYNC, REQUEST_ASYNC } from './actionTypes';
export declare type TransformFunction = (body: any, text?: string, response?: Response) => {
    [id: string]: any;
};
export declare type UpdateFunction = (prevValue: any, value: any) => any;
export interface UpdateFunctionMap {
    [id: string]: UpdateFunction;
}
export interface HttpOptions {
    method?: 'DELETE' | 'GET' | 'HEAD' | 'POST' | 'PUT';
    headers?: {
        [key: string]: any;
    };
    credentials?: 'include';
}
export interface BaseParams {
    body?: Object;
    meta?: Object;
    url: string;
    queryKey?: string;
}
export interface RequestParams extends BaseParams {
    force?: boolean;
    options?: HttpOptions;
    retry?: boolean;
    transform?: TransformFunction;
    update: UpdateFunctionMap;
}
export interface RequestAsyncAction extends RequestParams, Action {
    type: typeof REQUEST_ASYNC;
}
export interface MutateParams extends BaseParams {
    options?: HttpOptions;
    optimisticUpdate?: UpdateFunctionMap;
    transform?: TransformFunction;
    update: UpdateFunctionMap;
}
export interface MutateAsyncAction extends MutateParams, Action {
    type: typeof MUTATE_ASYNC;
}
export declare const requestAsync: (params: RequestParams) => RequestAsyncAction;
export declare const mutateAsync: (params: MutateParams) => MutateAsyncAction;
